private import enemy;
private import enemy_move;
private import enemy_view;
private import common;

class EnemyMgr {
    static EnemyMove getRandomMove() {
        return moves_[rnd(moves_.length)]();
    }
    static EnemyMove getMove(char[] s) {
        return moveMap_[s]();
    }
    static EnemyView getRandomView(float x, float y) {
        return views_[rnd(views_.length)](x, y);
    }
    static EnemyView getView(char[] s, float x, float y) {
        return viewMap_[s](x, y);
    }

    static EnemyMove function()[] moves_;
    static EnemyMove function()[char[]] moveMap_;
    static EnemyView function(float x, float y)[] views_;
    static EnemyView function(float x, float y)[char[]] viewMap_;

    // auto generated

    static this() {
        moveMap_[`GrindShotMove`] = &newGrindShotMove;
        moves_ ~= &newGrindShotMove;
        moveMap_[`SurroMove`] = &newSurroMove;
        moves_ ~= &newSurroMove;
        moveMap_[`AlleMove`] = &newAlleMove;
        moves_ ~= &newAlleMove;
        moveMap_[`AtackMove`] = &newAtackMove;
        moves_ ~= &newAtackMove;
        moveMap_[`RollFireMove`] = &newRollFireMove;
        moves_ ~= &newRollFireMove;
        moveMap_[`TrackMove`] = &newTrackMove;
        moves_ ~= &newTrackMove;
        moveMap_[`TwoWayMove`] = &newTwoWayMove;
        moves_ ~= &newTwoWayMove;
        moveMap_[`ThreeWayMove`] = &newThreeWayMove;
        moves_ ~= &newThreeWayMove;
        moveMap_[`SniperMove`] = &newSniperMove;
        moves_ ~= &newSniperMove;
        moveMap_[`ThreeWayMoveNext`] = &newThreeWayMoveNext;
        moves_ ~= &newThreeWayMoveNext;
        moveMap_[`FastSurroMove`] = &newFastSurroMove;
        moves_ ~= &newFastSurroMove;
        moveMap_[`FanMove`] = &newFanMove;
        moves_ ~= &newFanMove;
        moveMap_[`GaraMove`] = &newGaraMove;
        moves_ ~= &newGaraMove;
        moveMap_[`AMove`] = &newAMove;
        moves_ ~= &newAMove;
        moveMap_[`BMove`] = &newBMove;
        moves_ ~= &newBMove;
        moveMap_[`CMove`] = &newCMove;
        moves_ ~= &newCMove;
        moveMap_[`DMove`] = &newDMove;
        moves_ ~= &newDMove;
        viewMap_[`ProtonView`] = &newProtonView;
        views_ ~= &newProtonView;
        viewMap_[`MiddleView`] = &newMiddleView;
        views_ ~= &newMiddleView;
    }
}

EnemyMove newGrindShotMove() { return new GrindShotMove(); }
EnemyMove newSurroMove() { return new SurroMove(); }
EnemyMove newAlleMove() { return new AlleMove(); }
EnemyMove newAtackMove() { return new AtackMove(); }
EnemyMove newRollFireMove() { return new RollFireMove(); }
EnemyMove newTrackMove() { return new TrackMove(); }
EnemyMove newTwoWayMove() { return new TwoWayMove(); }
EnemyMove newThreeWayMove() { return new ThreeWayMove(); }
EnemyMove newSniperMove() { return new SniperMove(); }
EnemyMove newThreeWayMoveNext() { return new ThreeWayMoveNext(); }
EnemyMove newFastSurroMove() { return new FastSurroMove(); }
EnemyMove newFanMove() { return new FanMove(); }
EnemyMove newGaraMove() { return new GaraMove(); }
EnemyMove newAMove() { return new AMove(); }
EnemyMove newBMove() { return new BMove(); }
EnemyMove newCMove() { return new CMove(); }
EnemyMove newDMove() { return new DMove(); }
EnemyView newProtonView(float x, float y) { return new ProtonView(x, y); }
EnemyView newMiddleView(float x, float y) { return new MiddleView(x, y); }
