#!/usr/bin/env ruby

moves = Array.new
File.open('enemy_move.d').each do |line|
  if (line =~ /class ([a-zA-Z]+) : EnemyMove/)
    moves.push($1)
  end
end

views = Array.new
File.open('enemy_view.d').each do |line|
  if (line =~ /class ([a-zA-Z]+) : EnemyView/)
    views.push($1)
  end
end

ofile = File.open('tmp.d', 'w')
ifile = File.open('enemy_mgr.d')
ifile.each do |line|
  ofile.print(line)

  if (line =~ /static this/)
    break
  end
end

moves.each do |m|
  ofile.print <<END
        moveMap_[`#{m}`] = &new#{m};
        moves_ ~= &new#{m};
END
end

views.each do |m|
  ofile.print <<END
        viewMap_[`#{m}`] = &new#{m};
        views_ ~= &new#{m};
END
end

ofile.print <<END
    }
}

END

moves.each do |m|
  ofile.print <<END
EnemyMove new#{m}() { return new #{m}(); }
END
end

views.each do |m|
  ofile.print <<END
EnemyView new#{m}(float x, float y) { return new #{m}(x, y); }
END
end

ifile.close
ofile.close

File.rename('tmp.d', 'enemy_mgr.d')
