#!/usr/lib/env ruby

class DM
  attr_accessor :name, :ret, :args

  def initialize(n, r, a)
    @name = n
    @ret = r
    @args = a
  end
end

dms = Array.new
File.open("enemy.d") do |ifile|
  ifile.each_line do |line|
    if (line =~ /--- for Io ---/)
      break
    end
  end

  ifile.each_line do |line|
    if (line =~ /    ([a-z]+) ([a-zA-Z]+)\(([a-z ,]*)\) \{/)
      ret = $1
      name = $2
      args = $3.split(/, /)

      dms.push(DM.new(name, ret, args))
    end
  end
end

all = ''
File.open("iointer.d") do |ifile|
  ifile.each do |line|
    all += line
    if (line =~ /--- generated codes ---/)
      all += "\n"
      break
    end
  end
end

File.open("iointer.d", 'w') do |ofile|
  ofile.print(all)

  dms.each do |dm|
    print "#{dm.ret} #{dm.name} #{dm.args.join(', ')}\n"

    ofile.print("IoObject* io_enemy_#{dm.name}(IoObject* self, IoObject* locals, IoMessage* m) {\n")

    anl = Array.new
    ofile.print "    Enemy elcl = handle2enemy[self];\n"
    dm.args.each_index do |i|
      (at, an) = dm.args[i].split(/ /)
      ofile.print "    #{at} #{an} = IoMessage_locals_#{at}ArgAt_(m, locals, #{i});\n"
      anl.push(an)
    end

    call = "elcl.#{dm.name}(#{anl.join(', ')})"
    if (dm.ret == "void")
      ofile.print "    #{call};\n"
      ofile.print "    return IoNil_new(ioState);\n"
    else
      ofile.print "    #{dm.ret} rlcl = #{call};\n"
      if (dm.ret == "float")
        ofile.print "    return IoNumber_newWithDouble_(ioState, rlcl);\n"
      else
        abort("unknown return type")
      end
    end
    ofile.print("}\n\n")
  end

  ofile.print("void enemy_init(IoState* state, IoObject* enemy) {\n")
  dms.each do |dm|
    ofile.print("    DIoObject_addMethod(state, enemy, \"#{dm.name}\", &io_enemy_#{dm.name});\n")
  end
  ofile.print("}\n\n")
end
