private import std.stream;
private import std.string;
private import std.c.stdlib;

private import SDL;

class Log {
    static void init() {
        version (Win32) {
            s = new File("out.txt", FileMode.OutNew);
        }
        else {
            s = stdout;
        }
    }
    static void quit() {
        version (Win32) {
            s.close();
        }
        s = null;
    }
    static Stream s;

    static bit errored = false;
    static void report(char[] tag, char[] msg) {
        s.writeLine("[" ~ tag ~ "] " ~ msg);
    }
    static void error(char[] msg) {
        report("ERROR", msg);
        errored = true;
        assert(false);
    }
    static void errorSDL(char[] msg) {
        error("[SDL] " ~ msg ~ ": " ~ std.string.toString(SDL_GetError()));
    }
    static void warn(char[] msg) {
        report("WARN", msg);
    }
    static void warnSDL(char[] msg) {
        warn("[SDL] " ~ msg ~ ": " ~ std.string.toString(SDL_GetError()));
    }
    static void info(char[] msg) {
        report("INFO", msg);
    }
    static void dbg(char[] msg) {
        debug {
            report("DBG", msg);
        }
    }
    static void dbg(int msg) {
        debug {
            report("DBG", std.string.toString(msg));
        }
    }
    static bit isErrored() {
        return errored;
    }

}
