private import std.string;

private import mygl;
private import common;
private import glbf;

private GLBitmapFont font;

void initLetter() {
    int ret = glbfInit(&font, `data/kochi.bmp`, 12, 14, 21);
    if (ret != 0) {
        Log.errorSDL("failed initialize font");
    }
    Log.info("initialize font");
}

void drawNum(int num, float x, float y, float sx, float sy,
             float r, float g, float b)
in {
    assert(num >= 0);
}
body {
    drawString(tostr(num), x, y, sx, sy, r, g, b);
}

void drawString(char[] str, float x, float y, float sx, float sy,
                float r, float g, float b, float a) {
    glEnable(GL_TEXTURE_2D);

    glPushMatrix();
    glTranslatef(x, y, 0);
    glScalef(sx/14, -sy/21, 1);

    glColor4f(r, g, b, a);

    glbfPrint(font, toStringz(str));

    glPopMatrix();
}

void drawString(char[] str, float x, float y, float sx, float sy,
                float r, float g, float b) {
    drawString(str, x, y, sx, sy, r, g, b, 1.0);
}

void drawStringR(char[] str, float x, float y, float sx, float sy,
                 float r, float g, float b, float a) {
    drawString(str, x-str.length*12*sx/14, y, sx, sy, r, g, b, a);
}

void drawStringC(char[] str, float x, float y, float sx, float sy,
                 float r, float g, float b, float a) {
    drawString(str, x-str.length*6*sx/14, y, sx, sy, r, g, b, a);
}
void drawStringC(char[] str, float x, float y, float sx, float sy,
                 float r, float g, float b) {
    drawString(str, x-str.length*6*sx/14, y, sx, sy, r, g, b, 1.0);
}

void drawNumR(int num, int x, int y, float sx, float sy,
              float r, float g, float b) {
    if (num != 0) {
        x -= sx * cast(int)(log10(num)) * 12 / 14;
    }
    drawNum(num, x, y, sx, sy, r, g, b);
}
