private import enemy;
private import enemy_mgr;
private import common;
private import game;
private import player;
private import pversion;

class PatternMgr {
    static void init() {
        patterns_.length = 0;
        patternIte_ = 0;
        patternLevel_ = 0;

        void addPattern(void delegate(out Pattern[] p) d) {
            patterns_.length = patterns_.length + 1;
            d(patterns_[patterns_.length-1]);
        }

        int n6 = 6;
        int n7 = 7;
        int n9 = 9;
        float one = 1.0;
        if (Game.obj.mode == Game.Mode.EASY) {
            n6 = 4;
            n7 = 5;
            n9 = 6;
            one = 0.5;
        }

        // 1
        addPattern(delegate void(out Pattern[] p) {
            for (int i = 0; i < n6; i++) {
                Pattern e = new Pattern();
                e.move = "TrackMove";
                e.view = "ProtonView";
                e.x = -1+rrnd(1.5);
                e.y = -1+rrnd(1.5);
                e.isTetrameric = true;
                p ~= e;
            }
        });
        // 2
        addPattern(delegate void(out Pattern[] p) {
            for (int i = 0; i < n6; i++) {
                Pattern e = new Pattern();
                e.move = "TwoWayMove";
                e.view = "ProtonView";
                e.x = cos(PI/n6*0.5*i)*1.1-0.1;
                e.y = sin(PI/n6*0.5*i)*1.1-0.1;
                e.isTetrameric = true;
                p ~= e;
            }
        });
        // 3
        addPattern(delegate void(out Pattern[] p) {
            for (int i = 0; i < n6; i++) {
                Pattern e = new Pattern();
                e.move = "ThreeWayMove";
                e.view = "ProtonView";
                e.x = cos(PI/n6*2*i)*0.5;
                e.y = sin(PI/n6*2*i)*0.5;
                e.param = PI/n6*2*i+PI/2;
                e.isTetrameric = true;
                p ~= e;
            }
        });
        // 4
        addPattern(delegate void(out Pattern[] p) {
            for (int i = 0; i < n6; i++) {
                Pattern e = new Pattern();
                e.move = "RollFireMove";
                e.view = "ProtonView";
                e.x = 0.5*cos(PI*i/n6*2);
                e.y = 0.5*sin(PI*i/n6*2);
                p ~= e;
            }
        });
        // 5
        addPattern(delegate void(out Pattern[] p) {
            Pattern e = new Pattern();
            e.move = "GrindShotMove";
            e.view = "MiddleView";
            e.x = 0;
            e.y = 0;
            e.param = one;
            if (versionNum >= 30 && Game.obj.mode == Game.Mode.EASY) {
                e.life = 3;
            }
            else {
                e.life = 5;
            }
            p ~= e;
        });
        // 6
        addPattern(delegate void(out Pattern[] p) {
            for (int i = 0; i < n6; i++) {
                Pattern e = new Pattern();
                e.move = "SurroMove";
                e.view = "ProtonView";
                e.x = cos(PI*i/n6*2);
                e.y = sin(PI*i/n6*2);
                p ~= e;
            }
        });
        // 7
        addPattern(delegate void(out Pattern[] p) {
            for (int i = 0; i < n6; i++) {
                Pattern e = new Pattern();
                e.move = "RollFireMove";
                e.view = "ProtonView";
                e.x = -0.3+0.3*cos(PI*i/n6*2);
                e.y = -0.3+0.3*sin(PI*i/n6*2);
                e.isTetrameric = true;
                p ~= e;
            }
        });
        // 8
        addPattern(delegate void(out Pattern[] p) {
            for (int i = 0; i < n7; i++) {
                Pattern e = new Pattern();
                e.move = "AlleMove";
                e.view = "ProtonView";
                e.x = rrnd(2.0)-1.0;
                e.y = rrnd(2.0)-1.0;
                p ~= e;
            }
        });
        // 9
        addPattern(delegate void(out Pattern[] p) {
            for (int i = 0; i < n7; i++) {
                Pattern e = new Pattern();
                e.move = "SniperMove";
                e.view = "ProtonView";
                e.x = -1+rrnd(2.0);
                e.y = -1+rrnd(2.0);
                e.param = 1.0;
                e.isTetrameric = true;
                p ~= e;
            }
        });
        // 10
        addPattern(delegate void(out Pattern[] p) {
            for (int i = 0; i < n6; i++) {
                Pattern e = new Pattern();
                e.move = "ThreeWayMoveNext";
                e.view = "ProtonView";
                e.x = cos(PI/n6*2*i)*0.7;
                e.y = sin(PI/n6*2*i)*0.7;
                e.param = PI/n6*2*i+PI/2;
                e.isTetrameric = true;
                p ~= e;
            }
        });
        // 11
        addPattern(delegate void(out Pattern[] p) {
            Pattern e = new Pattern();
            e.move = "GrindShotMove";
            e.view = "MiddleView";
            e.x = 0;
            e.y = 0;
            e.param = 3.0*one;
            if (versionNum >= 30 && Game.obj.mode == Game.Mode.EASY) {
                e.life = 5;
            }
            else {
                e.life = 7;
            }
            p ~= e;
        });
        // 12
        addPattern(delegate void(out Pattern[] p) {
            for (int i = 0; i < n9; i++) {
                Pattern e = new Pattern();
                e.move = "FastSurroMove";
                e.view = "ProtonView";
                e.x = 1.2-1.4*cos(PI/24*i);
                e.y = 1.2-1.4*sin(PI/24*i);
                e.param = 0.2*i;
                e.life = 0.5;
                e.isTetrameric = true;
                p ~= e;
            }
        });
/*
        addPattern(delegate void(out Pattern[] p) {
            for (int i = 0; i < n6; i++) {
                Pattern e = new Pattern();
                e.move = "GrindShotMove";
                e.view = "ProtonView";
                e.x = rrnd(0.5);
                e.y = rrnd(0.5);
                e.param = 1.0;
                e.isTetrameric = true;
                p ~= e;
            }
        });
*/
        // 13
        addPattern(delegate void(out Pattern[] p) {
            for (int i = 0; i < n6; i++) {
                Pattern e = new Pattern();
                e.move = "AtackMove";
                e.view = "ProtonView";
                e.x = cos(PI*i/n6*2);
                e.y = sin(PI*i/n6*2);
                p ~= e;
            }
        });
        // 14
        addPattern(delegate void(out Pattern[] p) {
            for (int i = 0; i < n7; i++) {
                Pattern e = new Pattern();
                e.move = "GaraMove";
                e.view = "ProtonView";
                e.x = -1+rrnd(2.0);
                e.y = -1+rrnd(2.0);
                //e.isTetrameric = true;
                p ~= e;
            }
        });
        // 15
        addPattern(delegate void(out Pattern[] p) {
            for (int i = 0; i < n6; i++) {
                Pattern e = new Pattern();
                e.move = "FanMove";
                e.view = "ProtonView";
                e.x = -1+rrnd(2.0);
                e.y = -1+rrnd(2.0);
                e.isTetrameric = true;
                p ~= e;
            }
        });

        // 16
        addPattern(delegate void(out Pattern[] p) {
            for (int i = 0; i < n6; i++) {
                Pattern e = new Pattern();
                e.move = "AMove";
                e.view = "ProtonView";
                e.x = -1+rrnd(1.5);
                e.y = -1+rrnd(1.5);
                e.isTetrameric = true;
                e.life = 2;
                p ~= e;
            }
        });
        // 17
        addPattern(delegate void(out Pattern[] p) {
            for (int i = 0; i < n6; i++) {
                Pattern e = new Pattern();
                e.move = "BMove";
                e.view = "ProtonView";
                e.x = rrnd(2.0)-1.0;
                e.y = rrnd(2.0)-1.0;
                e.life = 2;
                p ~= e;
            }
        });
        // 18
        addPattern(delegate void(out Pattern[] p) {
            for (int i = 0; i < n6; i++) {
                Pattern e = new Pattern();
                e.move = "CMove";
                e.view = "ProtonView";
                e.x = cos(PI/n6*2*i)*0.5;
                e.y = sin(PI/n6*2*i)*0.5;
                e.param = PI/n6*2*i+PI/2;
                e.isTetrameric = true;
                e.life = 2;
                p ~= e;
            }
        });
        // 19
        addPattern(delegate void(out Pattern[] p) {
            for (int i = 0; i < n6; i++) {
                Pattern e = new Pattern();
                e.move = "DMove";
                e.view = "ProtonView";
                e.x = 0.7*cos(PI*i/n6*2);
                e.y = 0.7*sin(PI*i/n6*2);
                e.life = 2;
                p ~= e;
            }
        });
        // 20
        addPattern(delegate void(out Pattern[] p) {
            Pattern e = new Pattern();
            e.move = "GrindShotMove";
            e.view = "MiddleView";
            e.x = 0;
            e.y = 0;
            e.param = 10.0*one;
            if (versionNum >= 30 && Game.obj.mode == Game.Mode.EASY) {
                e.life = 7;
            }
            else {
                e.life = 10;
            }
            p ~= e;
        });

    }

    static void addRandomPattern() {
        int r = rrnd(patterns_.length);
        addPattern(r, 0);
    }

    static bool addNextPattern() {
        if (patternIte_ == patterns_.length) {
            if (Game.obj.mode != Game.Mode.ENDLESS) {
                return false;
            }
            else {
                patternIte_ = 0;
                patternLevel_++;
            }
        }
        addPattern(patternIte_++, patternLevel_);
        return true;
    }

    static void addPattern(int r, int level) {
        Pattern[] pat = patterns_[r];

        int patNum = r + level * 20;

        Enemy[] enemies;
        foreach (Pattern p; pat) {
            float x, y;
            if (p.setXY) {
                p.setXY(x, y);
            }
            else {
                x = p.x;
                y = p.y;
            }

            int fw = Game.obj.fieldWidth;
            int fh = Game.obj.fieldHeight;
            if (p.isTetrameric) {
                x = (x+1) * fw * 0.25;
                y = (y+1) * fh * 0.25;
                Player p = Game.obj.player;
                if (p.x < (fw>>1)) {
                    x = fw - x;
                }
                if (p.y < (fh>>1)) {
                    y = fh - y;
                }
            }
            else {
                x = (x*0.99+1+0.01) * fw * 0.5;
                y = (y*0.99+1+0.01) * fh * 0.5;
            }

            Enemy e = new Enemy(x, y,
                                EnemyMgr.getView(p.view, x, y),
                                EnemyMgr.getMove(p.move), p.param, patNum);
            if (isnan(p.life)) p.life = 1.0;
            e.setLife(p.life * 0.5 * (level+2));

            enemies ~= e;
        }
        Game.obj.addEnemyPattern(patNum, enemies);
    }

private:
    class Pattern {
        char[] move;
        char[] view;
        float x, y;
        void function (out float x, out float y) setXY;
        bool isTetrameric;
        float param;
        float life;
    }
    static Pattern[][] patterns_;
    static int patternIte_;
    static int patternLevel_;
}
