private import sound;
private import game;
private import mymath;

private import SDL;
private import common;
private import std.string;
class SoundPhase {
    static void init() {
        startTicks = SDL_GetTicks();
        pt = st = ptt = stt = 0.0f;
    }

    static float phase() {
        float tt;
        if (Game.obj.mode == Game.Mode.ENDLESS) {
            tt = phaseEndless();
        }
        else {
            tt = phaseNormal();
        }

        stt = (stt + tt - ptt) / 2;

        if (st > 0) {
            if (stt <= 0) {
                st -= 0.05;
            }
            else if (tt > pt + st) {
                if (stt < st * 0.8) {
                    st += 0.05;
                    if (stt < st * 0.8) {
                        st = stt / 0.8;
                    }
                }
                else {
                    st += 0.05;
                }
            }
            else {
                if (stt > st / 0.8) {
                    st -= 0.05;
                    if (stt > st / 0.8) {
                        st = stt * 0.8;
                    }
                }
                else {
                    st -= 0.05;
                }
            }
        }
        else {
            if (stt > 0) {
                st += 0.05;
            }
            else if (tt > pt + st) {
                if (stt < st / 0.8) {
                    st += 0.05;
                    if (stt < st / 0.8) {
                        st = stt * 0.8;
                    }
                }
                else {
                    st += 0.05;
                }
            }
            else {
                if (stt > st * 0.8) {
                    st -= 0.05;
                    if (stt > st * 0.8) {
                        st = stt / 0.8;
                    }
                }
                else {
                    st -= 0.05;
                }
            }
        }

        float t = pt + st;
        pt = t;
        ptt = tt;

        return t;
    }

private:
    static float phaseEndless() {
        static int r = 2;
        static float pt = 0;
        static int ptick = 0;

        if (ptick == 0) ptick = startTicks + 100;

        int tick = SDL_GetTicks();
        float elapsed = tick - ptick;
        ptick = tick;

        if (rnd(6000) == 0) {
            r = rnd(5)-2;
            while (r == 0 && tick < 200000) {
                r = rnd(5)-2;
            }
        }

        pt += elapsed*0.15*r;

        return pt;
    }

    static float phaseNormal() {
        float elapsed = SDL_GetTicks() - startTicks + 100;
        float tt;
        if (elapsed < 24000) {
            tt = elapsed*0.3;
        }
        else if (elapsed < 48000) {
            tt = 3600 + elapsed*0.15;
        }
        else if (elapsed < 72000) {
            tt = -3600 + elapsed*0.3;
        }
        else if (elapsed < 121800) {
            tt = 7200 + elapsed*0.15;
        }
        else if (elapsed < 133800) {
            tt = 43740 - elapsed*0.15;
        }
        else if (elapsed < 160000) {
            tt = 23670 - (elapsed-133800)*0.28;
        }
        else if (elapsed < 184000) {
            tt = 16334 - (elapsed-160000)*0.15;
        }
        else if (elapsed < 232000) {
            tt = 12734 - (elapsed-184000)*0.3;
        }
        else {
            tt = -1666;
        }

        return tt;
    }

    static int startTicks;
    static float pt, st, ptt, stt;
}
