private import common;
private import mygl;
private import obj;
private import texture;
private import game;
private import objspecs;

class Thunder : Obj {
    mixin HasAbsolutePush;

    alias void delegate(inout float x, inout float y,
                        inout float sx, inout float sy) MoveFunc;

    static const int width = 21;
    static const float dlife = 1.0 / 30;

    this(float x, float y, float sx, float sy, float[3] col,
         MoveFunc moveFunc) {
        x_ = x;
        y_ = y;
        sx_ = sx;
        sy_ = sy;
        t_ = 0;
        life_ = 1;
        moveFunc_ = moveFunc;
    }
    override void move() {
        t_++;
        life_ -= dlife;
        hx_ ~= x_;
        hy_ ~= y_;

        x_ += sx_;
        y_ += sy_;

        if (moveFunc_ === null) {
            float rs() { return rnd(15)-7; }
            sx_ += rs;
            sy_ += rs;
        }
        else {
            moveFunc_(x_, y_, sx_, sy_);
        }
    }
    void draw() {
        pushMatrix();

        GLfloat[] tmp = Texture.prepare(TextureID.TEX_PARTICLE);
        GLfloat[4] texcoord;
        texcoord[0] = tmp[0]*0.9+tmp[2]*0.1;
        //texcoord[1] = tmp[1]*0.66+tmp[3]*0.33;
        texcoord[1] = tmp[1]*0.66+tmp[3]*0.33;
        texcoord[2] = tmp[2]*0.9+tmp[0]*0.1;
        //texcoord[3] = tmp[3]*0.66+tmp[1]*0.33;
        texcoord[3] = tmp[3]*0.66+tmp[1]*0.33;

        glColor4f(col_[0], col_[1], col_[2], life_*0.8);
        glBegin(GL_QUADS);
        float rs() { return rnd(width) - width/2; }
        for (int i = 0; i < t_-1; i++) {
            glTexCoord3f(texcoord[0], texcoord[1], 0);
            glVertex2f(hx_[i], hy_[i]);
            glTexCoord3f(texcoord[2], texcoord[1], 0);
            glVertex2f(hx_[i]+rs(), hy_[i]+rs());
            glTexCoord3f(texcoord[2], texcoord[3], 0);
            glVertex2f(hx_[i+1]+rs(), hy_[i+1]+rs());
            glTexCoord3f(texcoord[0], texcoord[3], 0);
            glVertex2f(hx_[i+1], hy_[i+1]);
        }
        glEnd();

        glPopMatrix();
    }

    override bool alive() { return life_ > 0; }

    float x_, y_, sx_, sy_;
    float[] hx_, hy_;
    float life_;
    int t_;
    float[3] col_;
    MoveFunc moveFunc_;
}
